# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mir_actions/MirMoveBaseResult.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class MirMoveBaseResult(genpy.Message):
  _md5sum = "5d78ef95801ef85ff0171f7a59e041d7"
  _type = "mir_actions/MirMoveBaseResult"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#result definition
int16 UNDEFINED = 0
int16 GOAL_REACHED = 1
int16 FAILED = -1
int16 FAILED_NO_PATH = -2
int16 FAILED_GOAL_IN_STATIC_OBSTACLE = -3
int16 FAILED_GOAL_IN_FORBIDDEN_AREA = -4
int16 FAILED_GOAL_IN_DYNAMIC_OBSTACLE = -5
int16 FAILED_ROBOT_IN_COLLISION = -6
int16 FAILED_ROBOT_IN_FORBIDDEN_AREA = -7
int16 FAILED_UNKNOWN_TRAILER = -8
int16 end_state
geometry_msgs/PoseStamped end_pose

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  # Pseudo-constants
  UNDEFINED = 0
  GOAL_REACHED = 1
  FAILED = -1
  FAILED_NO_PATH = -2
  FAILED_GOAL_IN_STATIC_OBSTACLE = -3
  FAILED_GOAL_IN_FORBIDDEN_AREA = -4
  FAILED_GOAL_IN_DYNAMIC_OBSTACLE = -5
  FAILED_ROBOT_IN_COLLISION = -6
  FAILED_ROBOT_IN_FORBIDDEN_AREA = -7
  FAILED_UNKNOWN_TRAILER = -8

  __slots__ = ['end_state','end_pose']
  _slot_types = ['int16','geometry_msgs/PoseStamped']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       end_state,end_pose

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MirMoveBaseResult, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.end_state is None:
        self.end_state = 0
      if self.end_pose is None:
        self.end_pose = geometry_msgs.msg.PoseStamped()
    else:
      self.end_state = 0
      self.end_pose = geometry_msgs.msg.PoseStamped()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_h3I().pack(_x.end_state, _x.end_pose.header.seq, _x.end_pose.header.stamp.secs, _x.end_pose.header.stamp.nsecs))
      _x = self.end_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.end_pose.pose.position.x, _x.end_pose.pose.position.y, _x.end_pose.pose.position.z, _x.end_pose.pose.orientation.x, _x.end_pose.pose.orientation.y, _x.end_pose.pose.orientation.z, _x.end_pose.pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.end_pose is None:
        self.end_pose = geometry_msgs.msg.PoseStamped()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.end_state, _x.end_pose.header.seq, _x.end_pose.header.stamp.secs, _x.end_pose.header.stamp.nsecs,) = _get_struct_h3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.end_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.end_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.end_pose.pose.position.x, _x.end_pose.pose.position.y, _x.end_pose.pose.position.z, _x.end_pose.pose.orientation.x, _x.end_pose.pose.orientation.y, _x.end_pose.pose.orientation.z, _x.end_pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_h3I().pack(_x.end_state, _x.end_pose.header.seq, _x.end_pose.header.stamp.secs, _x.end_pose.header.stamp.nsecs))
      _x = self.end_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.end_pose.pose.position.x, _x.end_pose.pose.position.y, _x.end_pose.pose.position.z, _x.end_pose.pose.orientation.x, _x.end_pose.pose.orientation.y, _x.end_pose.pose.orientation.z, _x.end_pose.pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.end_pose is None:
        self.end_pose = geometry_msgs.msg.PoseStamped()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.end_state, _x.end_pose.header.seq, _x.end_pose.header.stamp.secs, _x.end_pose.header.stamp.nsecs,) = _get_struct_h3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.end_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.end_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.end_pose.pose.position.x, _x.end_pose.pose.position.y, _x.end_pose.pose.position.z, _x.end_pose.pose.orientation.x, _x.end_pose.pose.orientation.y, _x.end_pose.pose.orientation.z, _x.end_pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_h3I = None
def _get_struct_h3I():
    global _struct_h3I
    if _struct_h3I is None:
        _struct_h3I = struct.Struct("<h3I")
    return _struct_h3I
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
